---
title: 'TextTrack: cuechange event'
slug: Web/API/TextTrack/cuechange_event
tags:
  - API
  - Event
  - Reference
  - TextTrack
  - WebVTT
  - cuechange
  - oncuechange
  - track
---
<div>{{APIRef}}</div>

<p><span class="seoSummary">The <strong><code>cuechange</code></strong> event fires when a {{domxref("TextTrack")}} has changed the currently displaying cues.</span> The event is fired at both the <code>TextTrack</code> <em>and</em> at the {{domxref("HTMLTrackElement")}} in which it's being presented, if any.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("Event")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{domxref("GlobalEventHandlers.oncuechange")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<h3 id="On_the_TextTrack">On the TextTrack</h3>

<p>You can set up a listener for the <code>cuechange</code> event on a <code>TextTrack</code> using the {{domxref("EventTarget.addEventListener", "addEventListener()")}} method:</p>

<pre class="brush: js">track.addEventListener('cuechange', function () {
  let cues = track.activeCues;  // array of current cues
});
</pre>

<p>Or you can just set the {{domxref("GlobalEventHandlers.oncuechange", "oncuechange")}} event handler property:</p>

<pre class="brush: js">track.oncuechange = function () {
  let cues = track.activeCues; // array of current cues
}</pre>

<h3 id="On_the_track_element">On the track element</h3>

<p>The underlying {{domxref("TextTrack")}}, indicated by the {{domxref("HTMLTrackElement.track", "track")}} property, receives a {{domxref("TextTrack.cuechange_event", "cuechange")}} event every time the currently-presented cue is changed. This happens even if the track isn't associated with a media element.</p>

<p>If the track <em>is</em> associated with a media element, using the {{HTMLElement("track")}} element as a child of the {{HTMLElement("audio")}} or {{HTMLElement("video")}} element, the <code>cuechange</code> event is also sent to the {{domxref("HTMLTrackElement")}}.</p>

<pre class="brush: js">let textTrackElem = document.getElementById("texttrack");

textTrackElem.addEventListener("cuechange", (event) =&gt; {
  let cues = event.target.track.activeCues;
});
</pre>

<p>In addition, you can use the <code>oncuechange</code> event handler:</p>

<pre class="brush: js">let textTrackElem = document.getElementById("texttrack");

textTrackElem.oncuechange = (event) =&gt; {
  let cues = event.target.track.activeCues;
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', '#event-media-cuechange', 'cuechange')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a class="external" href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("api.TextTrack.cuechange_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{glossary("WebVTT")}}</li>
</ul>
